# first set the working directory to the directory where this script is located
# in RStudio: Session->Set Working Directory->To Source File Location 
# then: just 'source' this script 

rm(list=ls())

prodloss    = read.delim("./data/prodloss_dw.txt")
GDP         = read.delim("./data/GDP_all_countries_by_PPP_quintile_USD_PPP.txt")
CF.cases   = read.delim(file="./data/oncho-cases-skin-disease-CF.txt")
RC.cases   = read.delim(file="./data/oncho-cases-skin-disease-RC.txt")
discounting = 1/(1.03^(0:20))

df.averted.costs = function(prodloss,GDP,CF.matrix,RC.matrix,disc,seq.index=1){
  p = prodloss$prod_loss[prodloss$seqid==seq.index] 
  CF=CF.matrix[order(rownames(CF.matrix)),]
  GDP.CF=GDP[GDP$country %in% rownames(CF),]
  CF.prodloss = apply(CF * GDP.CF$Q1 * p,2,sum)
  CF.prodloss.USD = apply(CF * GDP.CF$Q1 * GDP.CF$USD_2005/GDP.CF$PPP_2005 * p,2,sum)
  
  RC=RC.matrix[order(rownames(RC.matrix)),]
  GDP.RC=GDP[GDP$country %in% rownames(RC),]
  RC.prodloss = apply(RC * GDP.RC$Q1 * p,2,sum)
  RC.prodloss.USD = apply(RC * GDP.RC$Q1 * GDP.RC$USD_2005/GDP.RC$PPP_2005 * p,2,sum)
  
  averted = CF.prodloss-RC.prodloss
  averted.USD = CF.prodloss.USD-RC.prodloss.USD
  
  PPP.1 = round(sum((disc*(averted[21:41]))[2:11]/1e9),5)
  PPP.2 = round(sum((disc*(averted[21:41]))[12:21]/1e9),5)
  USD.1 = round(sum((disc*(averted.USD[21:41]))[2:11]/1e9),5)
  USD.2 = round(sum((disc*(averted.USD[21:41]))[12:21]/1e9),5)
  data.frame(sequela=prodloss$sequela[seq.index],seq.nr=seq.index,PPP.averted.2011_2020=PPP.1,PPP.averted.2021_2030=PPP.2,USD.averted.2011_2020=USD.1,USD.averted.2021_2030=USD.2)
}

print("averted costs in billions of PPP or USD dollars")
print(df.averted.costs(prodloss,GDP,CF.cases,RC.cases,discounting))
